;TIP1045B.LSP:  COPYATTR.LSP     Attribute Utilities     (C)1994, Robert L. Zipprich

(defun C:COPYATTR ()
   (prompt "\nCOPYATTR: Copies Attributes from One block to MATCHING TAGS of another.")

   (Setq BLK1 (car (entsel "\nSelect Old Block with attributes to copy: "))
      EBLK1 BLK1   ; to erase old block
      BLK2 (car (entsel "\nSelect New Block to copy those attributes to: "))
   )
   (setq BLKNAME (cdr (assoc 2  (entget EBLK1)))
      INSPT   (cdr (assoc 10 (entget BLK2)))
   )
   ;---------------
   (setq BLK1 (entnext BLK1) DATA1 (entget BLK1))     ;primes the pump
   (while (/= "SEQEND" (cdr (assoc 0 DATA1)))         ;steps from ent to ent in 1st blk
      (if (setq TAGNAME1 (cdr (assoc 2 DATA1)))      ;if ent is attrib
         (progn
            (setq SWDATA (cdr (assoc 1 DATA1)))       ;1st attrib value
            (setq BLKENT (entnext BLK2) DATA2 (entget BLKENT))  ;next ent in 2nd blk
            (while (/= "SEQEND" (cdr (assoc 0 DATA2)))
               (if (eq TAGNAME1 (cdr (assoc 2 DATA2)))  ;if tags match
                  (progn
                     (Setq DATA2 (subst (cons 1 SWDATA) (assoc 1 DATA2) DATA2))
                     (entmod DATA2)             ;modifies 2nd attrib value
                     (setq BLKENT (entnext BLKENT) DATA2 (entget BLKENT)) ;set to next ent in 2nd blk
                  )
                  (setq BLKENT (entnext BLKENT) DATA2 (entget BLKENT)) ;set to next ent in 2nd blk
               )
            )
            (setq BLK1 (entnext BLK1) DATA1 (entget BLK1)) ;set to next ent in 1st blk
         )
         (setq BLK1 (entnext BLK1) DATA1 (entget BLK1)) ;set to next ent in 1st blk
      )
   )
   (princ)
) ; end copyattr.lsp
